routes/web.php
<?php

use App\Http\Controllers\CategoriesController;
use App\Http\Controllers\ClaimsController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\UsersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/', [CategoriesController::class, 'index']);

Route::resource('page', PagesController::class);

Route::resource('categories', CategoriesController::class)->only('index', 'show');

Route::resource('books.claims', ClaimsController::class);

Route::post('books.claims', [ClaimsController::class, 'store']);

Route::get('/users/register', [UsersController::class, 'register'])->name('users.register');
Route::post('/users', [UsersController::class, 'store'])->name('users.store');


Route::get('/login', [App\Http\Controllers\SessionsController::class, 'create'])->name('sessions.login');
Route::post('/login', [App\Http\Controllers\SessionsController::class, 'store'])->name('sessions.store');
Route::delete('/logout', [App\Http\Controllers\SessionsController::class, 'destroy'])->name('sessions.delete');

app/Models/Claim.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class Claim extends Model
{
    use HasFactory;

    /**
     * @var string[]
     */
    protected $fillable = ['user_id', 'book_id','date'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function book(): BelongsTo
    {
        return $this->belongsTo(Book::class);
    }
}

app/Http/Controllers/ClaimsController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ClaimRequest;
use App\Models\Book;
use App\Models\Claim;
use Carbon\Carbon;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class ClaimsController extends Controller
{

    /**
     * @param Book $book
     * @return Application|Factory|View
     */
    public function index(Book $book)
    {
        $claims = Claim::all();
        return view('claims.index', compact('claims', 'book'));
    }


    /**
     * @param Book $book
     * @return Application|Factory|View
     */
    public function create(Book $book)
    {
        $library_card = auth_user()->library_card;
        return view('claims.create', compact('book','library_card'));
    }

    /**
     * @param ClaimRequest $request
     * @param Book $book
     * @return RedirectResponse
     */
    public function store(ClaimRequest $request, Book $book):RedirectResponse
    {
        $date = $request->input('date');

        if($book->status == 'receive'){
            $book->status = 'expected';
        } else {
            $book->status = 'receive';
        }
        $book->return_date = Carbon::parse($date);
        $book->save();

        $claim= new Claim();
        $claim->user_id = auth_user()->id;
        $claim->book_id = $book->id;
        $claim->date = Carbon::parse($date);
        $claim->save();
        return redirect()->route('categories.index');
    }

}

resources/views/claims/create.blade.php
@extends('layouts.base')
@section('content')

    <h3>Application form</h3>

    <form enctype="multipart/form-data" method="post" action="{{route('books.claims.store', ['book'=> $book])}}">
        @csrf
        <div class="form-group">
            <label for="library_card">Library card</label>
            <input type="text" class="form-control" id="library_card" name="library_card" value="{{$library_card}}" disabled>
        </div>
        <div class="form-group">
            <input type="hidden" class="form-control" id="book_id" name="book_id">
        </div>
        <div class="form-group">
            <label for="author">Book author</label>
            <input type="text" class="form-control" id="author" name="author" value="{{$book->author}}" disabled>
        </div>
        <div class="form-group">
            <label for="title">Book title</label>
            <input type="text" class="form-control" id="title" name="title" value="{{$book->title}}" disabled>
        </div>
        <div class="form-group">
            <label for="return_date">Return date</label>
            <input type="text" class="form-control border-success  @error('date') is-invalid border-danger
                        @enderror" id="return_date" name="date">
        </div>
        @error('date')
        <p class="text-danger">{{ $message }}</p>
        @enderror
        <button type="submit" class="btn btn-outline-danger">Apply</button>
    </form>

@endsection

resources/views/claims/index.blade.php
@extends('layouts.base')
@section('content')
    @include('notifications.alerts')

    <h2>{{auth_user()->name}}</h2>

    <h3>All claims</h3>

    <table class="table">
        <thead>
        <tr>
            <th scope="col">Book title</th>
            <th scope="col">Return date</th>
            <th scope="col">Status</th>
        </tr>
        </thead>
        <tbody>
        @foreach($claims as $claim)
            @if(auth_user()->id == $claim->user_id)

                <tr>
                    <td>{{$claim->book->title}}</td>
                    <td>{{date($claim->date)}}</td>

                    @if($claim->book->status == 'receive')
                        <td>{{$claim->book->status}}</td>
                    @else
                        @if($claim->date <= Carbon\Carbon::now())
                            <td>{{$claim->book->status}}</td>
                        @else
                            <td>expired</td>
                        @endif
                </tr>
            @endif
            @endif

        @endforeach

        </tbody>
    </table>

@endsection